<div class="wrapper">
    <canvas bind:this={canvasElement} width="250" height="250" />
</div>

<script>
import { Chart } from '../shared/chart';
import * as colors from '../shared/colors';
import {fruitBasketService} from '../services/FruitBasketService'

let canvasElement
let chart
let {selectedFruitBasket} = fruitBasketService

function initChart() {
    chart = new Chart(canvasElement, {
        type: "pie",
        data: {
            datasets: [
                {
                    data: [
                        $selectedFruitBasket.nApples,
                        $selectedFruitBasket.nOranges
                    ],
                    backgroundColor: [colors.red, colors.orange]
                }
            ],
            labels: ["Apples", "Oranges"]
        }
    });
}

function updateChart() {
    chart.data.datasets[0].data = [
        $selectedFruitBasket.nApples,
        $selectedFruitBasket.nOranges,
    ];

    chart.update();
}

function subscriptionUpdated() {
    if (!canvasElement) return;
    if (!chart) {
        initChart(selectedFruitBasket)
    } else {
        updateChart()
    }
}

$: {
    $selectedFruitBasket
    subscriptionUpdated()
}

</script>

<style lang="scss">
@import '../styles/_variables';

.wrapper {
  background-color: $white;
  border-radius: 0.5rem;
  box-shadow: 1px 1px 3px $gray;
  overflow: hidden;
  padding: 2rem;
  width: 250px;
  height: 250px;
}

canvas {
  pointer-events: none;
}

</style>